Wt: Wt::WGridLayout Class Reference

Wt 3.3.0

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Hierarchy
- Class Members

Public Member Functions
Wt::WGridLayout Class Reference

A layout manager which arranges widgets in a grid. More...

`#include <Wt/WGridLayout>`

Inheritance diagram for Wt::WGridLayout:
[legend]

List of all members.

## Public Member Functions
| WGridLayout (WWidget *parent=0)
| Create a new grid layout.
virtual void | addItem (WLayoutItem *item)
| Adds a layout item.
virtual void | removeItem (WLayoutItem *item)
| Removes a layout item (widget or nested layout).
virtual WLayoutItem * | itemAt (int index) const
| Returns the layout item at a specific index.
virtual int | count () const
| Returns the number of items in this layout.
virtual void | clear ()
| Removes and deletes all child widgets and nested layouts.
void | addItem (WLayoutItem *item, int row, int column, int rowSpan=1, int columnSpan=1, WFlags< AlignmentFlag > alignment=0)
| Adds a layout item to the grid.
void | addLayout (WLayout *layout, int row, int column, WFlags< AlignmentFlag > alignment=0)
| Adds a nested layout item to the grid.
void | addLayout (WLayout *layout, int row, int column, int rowSpan, int columnSpan, WFlags< AlignmentFlag > alignment=0)
| Adds a nested layout item to the grid.
void | addWidget (WWidget *widget, int row, int column, WFlags< AlignmentFlag > alignment=0)
| Adds a widget to the grid.
void | addWidget (WWidget *widget, int row, int column, int rowSpan, int columnSpan, WFlags< AlignmentFlag > alignment=0)
| Adds a widget to the grid.
void | setHorizontalSpacing (int size)
| Sets the horizontal spacing.
int | horizontalSpacing () const
| Returns the horizontal spacing.
void | setVerticalSpacing (int size)
| Sets the vertical spacing.
int | verticalSpacing () const
| Returns the vertical spacing.
int | columnCount () const
| Returns the column count.
int | rowCount () const
| Returns the row count.
void | setColumnStretch (int column, int stretch)
| Sets the column stretch.
int | columnStretch (int column) const
| Returns the column stretch.
void | setRowStretch (int row, int stretch)
| Sets the row stretch.
int | rowStretch (int row) const
| Returns the column stretch.
void | setColumnResizable (int column, bool enabled=true, const WLength &initialSize=WLength::Auto)
| Sets whether the user may drag a particular column border.
bool | columnIsResizable (int column) const
| Returns whether the user may drag a particular column border.
void | setRowResizable (int row, bool enabled=true, const WLength &initialSize=WLength::Auto)
| Sets whether the user may drag a particular row border.
bool | rowIsResizable (int row) const
| Returns whether the user may drag a particular row border.

## Detailed Description

A layout manager which arranges widgets in a grid.

This layout manager arranges widgets in a grid.

Each grid cell (row, column) may contain one widget or nested layout. Horizontal and vertical space are divided so that each non-stretchable column/row is given its preferred size (if possible) and the remaining space is divided according to stretch factors among the columns/rows. If not all columns/rows can be given their preferred size (there is not enough room), then columns/rows are given a smaller size (down to a minimum size based on widget minimum sizes). If necessary, the container (or parent layout) of this layout is resized to meet minimum size requirements.

The preferred width/height of a column/row is based on the natural size of the widgets, where they present their contents without overflowing. WWidget::resize() or (CSS `width`, `height` properties) can be used to adjust the preferred size of a widget.

The minimum width/height of a column/row is based on the minimum dimensions of contained widgets or nested layouts. The default minimum height and width for a widget is 0. It can be specified using WWidget::setMinimumSize() or using CSS `min-width` and `min-height` properties.

You should use WContainerWidget::setOverflow(OverflowAuto) or use a WScrollArea to automatically show scrollbars for widgets inserted in the layout to cope with a size set by the layout manager that is smaller than the preferred size.

When the container of a layout manager has a maximum size set using WWidget::setMaximumSize(), then the size of the container will be based on the preferred size of the contents, up to this maximum size, instead of the default behaviour of constraining the size of the children based on the size of the container.

A layout manager may provide resize handles between columns or rows which allow the user to change the automatic layout provided by the layout manager (see setRowResizable() and setColumnResizable()).

Columns and rows are separated using a constant spacing, which defaults to 6 pixels by default, and can be changed using setHorizontalSpacing() and setVerticalSpacing(). In addition, when this layout is a top-level layout (i.e. is not nested inside another layout), a margin is set around the contents. This margin defaults to 9 pixels, and can be changed using setContentsMargins().

For each column or row, a stretch factor may be defined, which controls how remaining horizontal or vertical space is used. Each column and row is stretched using the stretch factor to fill the remaining space. When the stretch factor is 0, the height of the row and its contents is set to the preferred size (if possible). When the stretch factor is 1 or higher, these widgets will be given the remaining size, limited only by their minimum size (their preferred size is ignored).

Usage example:

     Wt::WContainerWidget *w = new Wt::WContainerWidget(this);
     w->resize(WLength::Auto, 600);

     Wt::WGridLayout *layout = new Wt::WGridLayout();
     layout->addWidget(new Wt::WText("Item 0 0"), 0, 0);
     layout->addWidget(new Wt::WText("Item 0 1"), 0, 1);
     layout->addWidget(new Wt::WText("Item 1 0"), 1, 0);
     layout->addWidget(new Wt::WText("Item 1 1"), 1, 1);

     w->setLayout(layout);

Note:
  This layout manager is applicable only to WContainerWidget container widgets. You may use it within an Ext::Container indirectly by first setting a WContainerWidget using a WFitLayout.
  When JavaScript support is not available, not all functionality of the layout is available. In particular, vertical size management is not available.
  When a layout is used on a first page with progressive bootstrap, then the layout will progress only in a limited way to a full JavaScript-based layout. You can thus not rely on it to behave properly for example when dynamically adding or removing widgets.

## Constructor & Destructor Documentation

Wt::WGridLayout::WGridLayout | ( | WWidget * | parent = `0` | ) |

Create a new grid layout.

The grid will grow dynamically as items are added.

Use `parent` = `0` to create a layout manager that can be nested inside other layout managers or if you use WContainerWidget::setLayout() to add specify the container later.

## Member Function Documentation

void Wt::WGridLayout::addItem | ( | WLayoutItem * | item | ) | `[virtual]`

Adds a layout item.

The item may be a widget or nested layout.

How the item is layed out with respect to siblings is implementation specific to the layout manager. In some cases, a layout manager will overload this method with extra arguments that specify layout options.

See also:
  removeItem(WLayoutItem *), addWidget(WWidget *)

Implements Wt::WLayout.

void Wt::WGridLayout::addItem | ( | WLayoutItem * | item,
|  | int | row,
|  | int | column,
|  | int | rowSpan = `1`,
|  | int | columnSpan = `1`,
|  | WFlags< AlignmentFlag > | alignment = `0`
| ) |  |

Adds a layout item to the grid.

Adds the item at (row, `column`). If an item was already added to that location, it is replaced (but not deleted).

An item may span several more rows or columns, which is controlled by rowSpan and `columnSpan`.

The `alignment` specifies the vertical and horizontal alignment of the item. The default value 0 indicates that the item is stretched to fill the entire grid cell. The alignment can be specified as a logical combination of a horizontal alignment (Wt::AlignLeft, Wt::AlignCenter, or Wt::AlignRight) and a vertical alignment (Wt::AlignTop, Wt::AlignMiddle, or Wt::AlignBottom).

See also:
  addLayout(), addWidget()

void Wt::WGridLayout::addLayout | ( | WLayout * | layout,
|  | int | row,
|  | int | column,
|  | WFlags< AlignmentFlag > | alignment = `0`
| ) |  |

Adds a nested layout item to the grid.

Adds the layout at (row, `column`). If an item was already added to that location, it is replaced (but not deleted).

The `alignment` specifies the vertical and horizontal alignment of the item. The default value 0 indicates that the item is stretched to fill the entire grid cell. The alignment can be specified as a logical combination of a horizontal alignment (Wt::AlignLeft, Wt::AlignCenter, or Wt::AlignRight) and a vertical alignment (Wt::AlignTop, Wt::AlignMiddle, or Wt::AlignBottom).

See also:
  addLayout(WLayout *, int, int, int, int, WFlags<AlignmentFlag>)

void Wt::WGridLayout::addLayout | ( | WLayout * | layout,
|  | int | row,
|  | int | column,
|  | int | rowSpan,
|  | int | columnSpan,
|  | WFlags< AlignmentFlag > | alignment = `0`
| ) |  |

Adds a nested layout item to the grid.

Adds the layout at (row, `column`). If an item was already added to that location, it is replaced (but not deleted).

An item may span several more rows or columns, which is controlled by rowSpan and `columnSpan`.

The `alignment` specifies the vertical and horizontal alignment of the item. The default value 0 indicates that the item is stretched to fill the entire grid cell. The alignment can be specified as a logical combination of a horizontal alignment (Wt::AlignLeft, Wt::AlignCenter, or Wt::AlignRight) and a vertical alignment (Wt::AlignTop, Wt::AlignMiddle, or Wt::AlignBottom).

See also:
  addLayout(WLayout *, int, int, WFlags<AlignmentFlag>)

void Wt::WGridLayout::addWidget | ( | WWidget * | widget,
|  | int | row,
|  | int | column,
|  | WFlags< AlignmentFlag > | alignment = `0`
| ) |  |

Adds a widget to the grid.

Adds the widget at (row, `column`). If an item was already added to that location, it is replaced (but not deleted).

The `alignment` specifies the vertical and horizontal alignment of the item. The default value 0 indicates that the item is stretched to fill the entire grid cell. The alignment can be specified as a logical combination of a horizontal alignment (Wt::AlignLeft, Wt::AlignCenter, or Wt::AlignRight) and a vertical alignment (Wt::AlignTop, Wt::AlignMiddle, or Wt::AlignBottom).

See also:
  addWidget(WWidget *, int, int, int, int, WFlags<AlignmentFlag>)

void Wt::WGridLayout::addWidget | ( | WWidget * | widget,
|  | int | row,
|  | int | column,
|  | int | rowSpan,
|  | int | columnSpan,
|  | WFlags< AlignmentFlag > | alignment = `0`
| ) |  |

Adds a widget to the grid.

Adds the widget at (row, `column`). If an item was already added to that location, it is replaced (but not deleted).

The widget may span several more rows or columns, which is controlled by rowSpan and `columnSpan`.

The `alignment` specifies the vertical and horizontal alignment of the item. The default value 0 indicates that the item is stretched to fill the entire grid cell. The alignment can be specified as a logical combination of a horizontal alignment (Wt::AlignLeft, Wt::AlignCenter, or Wt::AlignRight) and a vertical alignment (Wt::AlignTop, Wt::AlignMiddle, or Wt::AlignBottom).

See also:
  addWidget(WWidget *, int, int, WFlags<AlignmentFlag>)

void Wt::WGridLayout::clear | ( |  | ) | `[virtual]`

Removes and deletes all child widgets and nested layouts.

This is similar to WContainerWidget::clear(), with the exception that the layout itself is not deleted.

Implements Wt::WLayout.

int Wt::WGridLayout::columnCount | ( |  | ) | const

Returns the column count.

The grid dimensions change dynamically when adding contents to the grid.

See also:
  rowCount()

bool Wt::WGridLayout::columnIsResizable | ( | int | column | ) | const

Returns whether the user may drag a particular column border.

This method returns whether the border that separates column column from the next column may be resized by the user.

See also:
  setColumnResizable()

int Wt::WGridLayout::columnStretch | ( | int | column | ) | const

Returns the column stretch.

See also:
  setColumnStretch(int, int)

int Wt::WGridLayout::count | ( |  | ) | const`[virtual]`

Returns the number of items in this layout.

This may be a theoretical number, which is greater than the actual number of items. It can be used to iterate over the items in the layout, in conjunction with itemAt().

Implements Wt::WLayout.

int Wt::WGridLayout::horizontalSpacing | ( |  | ) | const

Returns the horizontal spacing.

See also:
  setHorizontalSpacing(int)

WLayoutItem * Wt::WGridLayout::itemAt | ( | int | index | ) | const`[virtual]`

Returns the layout item at a specific index.

If there is no item at the `index`, `0` is returned.

See also:
  indexOf(WLayoutItem *) const, count()

Implements Wt::WLayout.

void Wt::WGridLayout::removeItem | ( | WLayoutItem * | item | ) | `[virtual]`

Removes a layout item (widget or nested layout).

See also:
  addItem(WLayoutItem *), removeWidget(WWidget *)

Implements Wt::WLayout.

int Wt::WGridLayout::rowCount | ( |  | ) | const

Returns the row count.

The grid dimensions change dynamically when adding contents to the grid.

See also:
  columnCount()

bool Wt::WGridLayout::rowIsResizable | ( | int | row | ) | const

Returns whether the user may drag a particular row border.

This method returns whether the border that separates row row from the next row may be resized by the user.

See also:
  setRowResizable()

int Wt::WGridLayout::rowStretch | ( | int | row | ) | const

Returns the column stretch.

See also:
  setRowStretch(int, int)

void Wt::WGridLayout::setColumnResizable | ( | int | column,
|  | bool | enabled = `true`,
|  | const WLength & | initialSize = `WLength::Auto`
| ) |  |

Sets whether the user may drag a particular column border.

This method sets whether the border that separates column column from the next column may be resized by the user, depending on the value of enabled.

The default value is false.

If an `initialSize` is given (that is not WLength::Auto), then this size is used for the width of the column, overriding the width it would be given by the layout manager.

void Wt::WGridLayout::setColumnStretch | ( | int | column,
|  | int | stretch
| ) |  |

Sets the column stretch.

Sets the stretch factor for column `column`.

See also:
  columnStretch()

void Wt::WGridLayout::setHorizontalSpacing | ( | int | size | ) |

Sets the horizontal spacing.

The default horizontal spacing is 9 pixels.

See also:
  setVerticalSpacing(int)

void Wt::WGridLayout::setRowResizable | ( | int | row,
|  | bool | enabled = `true`,
|  | const WLength & | initialSize = `WLength::Auto`
| ) |  |

Sets whether the user may drag a particular row border.

This method sets whether the border that separates row row from the next row may be resized by the user, depending on the value of enabled.

The default value is false.

If an `initialSize` is given (that is not WLength::Auto), then this size is used for the height of the row, overriding the height it would be given by the layout manager.

void Wt::WGridLayout::setRowStretch | ( | int | row,
|  | int | stretch
| ) |  |

Sets the row stretch.

Sets the stretch factor for row `row`.

See also:
  rowStretch()

void Wt::WGridLayout::setVerticalSpacing | ( | int | size | ) |

Sets the vertical spacing.

The default vertical spacing is 9 pixels.

See also:
  setHorizontalSpacing(int)

int Wt::WGridLayout::verticalSpacing | ( |  | ) | const

Returns the vertical spacing.

See also:
  setVerticalSpacing(int)

All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator